%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Graph.oz ; This file is part of the OMEGA system
%
%   major updates: 4.12.1999,
%
%   Authors: Juergen Zimmer
%
%   email: jzimmer@ags.uni-sb.de
%   
% For information about this program, write to:                          
%   OMEGA Project                                                        
%   AG Siekmann/FB Informatik                                            
%   Universitaet des Saarlandes                                          
%   Bau 36, 4. Stock                                                     
%   D-66041 Saarbruecken                                                 
%   Germany    
%
% For information about the newest version of Omega, see 
%   http://www.ags.uni-sb.de/~omega/
%
% This program is free software; it can be used under the terms of the GNU General
% Public License as published by the Free Software Foundation; either version 2 of
% the License, or any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% merchantibility or fitness for a particular purpose. 
% See the GNU General Public License 
% (http://www.fsf.org/copyleft/gpl.html)
% for more details.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

functor
   %% The class of Cosie constraint solvers, Version 2.0
   %%      jzimmer 4.12.99 
   
import
   OS
   System(show: Show)
   Property

   RIDomain
   at 'x-ozlib://mathweb/cs/cosie/RIDomain.ozf'
   DaVinciGraph
   at 'x-ozlib://mathweb/cs/cosie/DaVinciGraph.ozf'
   
export
   MakeDependencyGraph
   ShowGraph
   
define
   {OS.putEnv 'DAVINCIHOME' "/project/omega/daVinci_V2.1"}
   {OS.putEnv 'PATH' {OS.getEnv 'PATH'}#":/project/omega/daVinci_V2.1"}
   {Property.put 'print.depth' 100}
   {Property.put 'print.width' 100}
   
   fun{MakeDependencyGraph Cons}  
      In = {NewDictionary}
      Out = {NewDictionary}
   in
      {ForAll Cons proc{$ C} {AddEntry C In Out} end}
      {Adjoin {Dictionary.toRecord children In} {Dictionary.toRecord children Out}}
   end
   
   proc{AddEntry Con In Out}
      Vars = {RIDomain.getVariables Con}
   in
      {Show con(Con vars: Vars)}
      {ForAll Vars proc{$ V1}
		      if {Dictionary.member Out V1} then skip
		      else {Dictionary.put Out V1 nil} end
		      OutEntries = {Dictionary.get Out V1}
		   in
		      {ForAll Vars
		       proc{$ V2}
			  if V1 == V2 then skip
			  else
			     if {Member V2 OutEntries} then skip
			     else
				{Dictionary.put Out V1 V2|OutEntries}
			     end
			  end
		       end}
		   end}
   end
   
   proc{ShowGraph G}
      Davin = {New DaVinciGraph.'class' init(Show)}
   in
      {Show G}
      {Davin show(children(a:[b] b:[a]))}
   end
   
end %define
