%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% RISimpRules.oz ; This file is part of the OMEGA system
%
%   major updates: 2.2.2000
%
%   Authors: Juergen Zimmer
%
%   email: jzimmer@ags.uni-sb.de
%   
% For information about this program, write to:                          
%   OMEGA Project                                                        
%   AG Siekmann/FB Informatik                                            
%   Universitaet des Saarlandes                                          
%   Bau 36, 4. Stock                                                     
%   D-66041 Saarbruecken                                                 
%   Germany    
%
% For information about the newest version of Omega, see 
%   http://www.ags.uni-sb.de/~omega/
%
% This program is free software; it can be used under the terms of the GNU General
% Public License as published by the Free Software Foundation; either version 2 of
% the License, or any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% merchantibility or fitness for a particular purpose. 
% See the GNU General Public License 
% (http://www.fsf.org/copyleft/gpl.html)
% for more details.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
		    
functor
   %% The constraint simplification rules used by the SymbolicSolverClass
   %%      jzimmer 20.4.99 
   
import
   
export
   constrSimpRules: AllRules
   TermRewriteRules
   NewConstrRules
define
   
   TermRewriteRules = [
		       
		       dummy()
		       
% 		       add_zero_right1(cons: [p1#'+'(a 0.0 b) p2#'/'(b c d) ]
% 				       del: [p1 p2]
% 				       add: ['/'(a c d)])
		       
% 		       %     (a+0)/c --> a/c
		       
% 		       add_zero_right2(cons: [p1#'+'(a 0.0 b) p2#'<='(b c) ]
% 				       del: [p1 p2]
% 				       add: ['<='(a c)])
% 		       %     (a+0) <= c --> a<=c
		       
% 		       add_zero_right3(cons: [p1#'+'(a 0.0 b) p2#'='(x#var b)]
% 				       del: [p1 p2]
% 				       add: ['='(x a)])
% 		       %     (a+0)=x#var --> x#var = a
		       
		       
		      ]
   
   ConstrAssRules =  [
		      dummy()
% 		      mult_two_geq_zero(cons: ['*'(2.0 a b)]
% 					ass: ['<='(0.0 a)]
% 					addAss: ['<='(0.0 b)]
% 					trace: [mult-two-geq-zero(lhs: ['<='(0.0 a)]
% 								  rhs: ['<='(0.0 b)])]
% 				       )
		      
		      div_two_greater_zero(cons: ['/'(a 2.0 b)]
					   ass: ['>'(a 0.0)]
					   addAss: ['>'(b 0.0)]
					   trace: ['div-two-greater-zero'(lhs: ['<'(0.0 a)]
									  rhs: ['<'(0.0 b)]
									  args: [a])
						  ])
		      
		      div_eps_geq_zero(cons: ['/'(a b c)]
				       ass: ['<='(0.0 a) '>'(b 0.0)]
				       addAss: ['<='(0.0 c)]
				       trace: nil)
		      
		     ]
   
   
   ConstrSimpRules = [
		      dummy()
		      
		      failure1(cons: ['<'(t1 t2) '<'(t2 t3) '<'(t3 t1)]
			       del: nil
			       add: failure)
		      %      t1 < t2 < t3 < t1    --> false
		      
		      solve_min_leq(cons: [p1#'<='(x#var b) p2#'<='(x c) p3#'>'(x d)]
				    ass: ['>'(b d) '>'(c d)]
				    del: [p1 p2 p3]
				    add: [ '<='(x 'MIN'(b c))]
				    trace: ['min-greater'(lhs: ['<'(d b) '<'(d c)]
							  rhs: ['<'(d 'MIN'(b c))]
							  args: [b c d]
							 )
					    'min-leq-left'(rhs: ['<='('MIN'(b c) b)]
							   args: [b c])
					    'min-leq-right'(rhs: ['<='('MIN'(b c) c)]
							    args: [b c])
					   ])
 		      %      d < x#var <=b & x<=c & d<b & d<c  --> x <= min(b c)
		      
		      solve_min_leq_simple(cons: [p1#'<='(x#var a) p2#'<='(x b)]
					   del: [p1 p2]
					   add: [ '<='(x 'MIN'(a b)) ]
					   trace: ['min-leq-left'(rhs: ['<='('MIN'(a b) a)]
								  args: [a b])
						   'min-leq-right'(rhs: ['<='('MIN'(a b) b)]
								   args: [a b])
						  ]
					  )  
		      %       x#var <=b & x<=c   --> x <= min(b c)
		      
		      solve_max_leq(cons: [p1#'<='(b x#var) p2#'<='(c x) p3#'<'(x d)]
				    ass: ['<'(b d) '<'(c d)]
				    del: [p1 p2]
				    add: [ '<='('MAX'(b c) x) ])
                      %      b<=x#var & c<=x  --> min(b c) <= x
		      
		      
		      greater_lower_leq1(cons: ['>='(x#var a) p#'>'(x b)]
					 ass:  ['<'(b a)]
					 del: [p]
					 add: nil
					 trace: ['less-leq-transitivity'(lhs: ['<'(b a) '<='(a x)]
									 rhs: ['<'(b x)]
									 args: [b a x]
									)
						])
		      
		      greater_lower_leq2(cons: [p1#'>='(x#var a) p2#'>'(x b)]
					 ass:  ['<='(b a)]
					 del: [p1 p2]
					 add: ['>'(x a)]
					 trace: ['leq-less-transitivity'(lhs: [ '<='(b a) '<'(a x)]
									 rhs: ['<'(b x)]
									 args: [b a x]
									)
						 'less-is-leq'(lhs: ['<'(a x)]
							       rhs: ['<='(a x)]
							       args: [a x])
						 
						])
		      
		      greater_lower_less(cons: [ p#'>'(x b) '>'(x#var a)]
					 ass:  ['<='(b a)]
					 del: [p]
					 add: nil
					 trace: ['less-less-transitivity'(lhs: ['<'(b a) '<'(a x)]
									  rhs: ['<'(b x)]
									  args: [b a x]
									 )
						])
% 	              greater_lower_leq3(cons: [p1#'<='(a x#var) p2#'>'(x 0.0) '*'(2.0 c a)]
% 					 ass:  ['<='(0.0 c)]
% 					 del: [p1 p2]
% 					 add: ['<'(a x)]
% 					 trace: [greater_lower_leq2(lhs: ['>='(x a) '>'(x 0.0)]
% 								   )
% 						])
		      
		      
% 		      greater_lower_guard(cons: ['>'(x#var b) p1#'>'(x c)]
% 					  ass: nil
% 					  guard: ['<='(c b)]
% 					  del: [p1]
% 					  add: nil)
		      
		      
% 		      mult_first_fac(cons: [p1#'>'(a b) p2#'/'(x#var c a)]
% 				     ass: nil
% 				     guard: ['>'(c 0.0)]
% 				     del: [p1 p2]
% 				     add: ['>'(x '*'(c b))]
% 				     trace: [mult_first_fac(lhs: ['>'('/'(x c) b) '>'(c 0.0)]
% 							    rhs: ['>'(x '*'(c b))]
% 							   )]
% 				    )
		      
% 		      mult_denom_less(cons: [p1#'>'(a b) p2#'/'(c d a) '*'(e x#var c) '>'(d 0.0)]
% 				      del: [p1 p2]
% 				      add: ['>'(c '*'(d b))])
% 		      %      (e * x#var)/d > b & d>0  -->  e * x#var > d * b
		      
		      mult_denom_leq_guard(cons: [p1#'<='(b a) '/'(x#var d a)]
					   guard: ['>'(d 0.0)]
					   del: [p1]
					   add: ['>='(x '*'(d b))]
					   trace: ['mult-frac-leq'(lhs: ['<='('*'(d b) x) '<'(0.0 d)]
								   rhs: ['<='(b '/'(x d))])
						  ]
					  )
		      %      x#var/d >= b & [d>0]  -->  x#var >=  d * b

		      mult_denom_less_guard(cons: [p1#'<'(b a) '/'(x#var d a)]
					    guard: ['>'(d 0.0)]
					    del: [p1]
					    add: ['>'(x '*'(d b))]
					    trace: ['mult-frac-less'(lhs: ['<'('*'(d b) x) '<'(0.0 d)]
								     rhs: ['<'(b '/'(x d))])
						   ]
					   )
		      %      x#var/d > b & [d>0]  -->  x#var >  d * b

% 		      div_first_fac(cons: [p1#'>'(a b) p2#'*'(c x#var a) '>'(c 0.0)]
% 				    del: [p1 p2]
% 				    add: ['>'(x '/'(b c))]
% 				   )
% 		      %      (c * c#var) > b & c>0  -->  x#var > b/c

		      div_first_fac(cons: [p1#'>'(a b) p2#'*'(c x#var a)]
				    ass: ['>'(c 0.0)]
				    del: [p1 p2]
				    add: ['>'(x '/'(b c))]
				   )
		      %      (c * c#var) > b & c>0  -->  x#var > b/c

		      'add_const='(cons: [p1#'='(a b) p2#'-'(x#var c a)]
				   del: [p1 p2]
				 add: ['='(x '+'(b c))]
				 trace: ['add-both-sides'(lhs: ['='(x '+'(b c))]
							  rhs: ['='('-'(x c) b)])
					]
				)
		      %      (x#var - c) = b   -->  x#var = b + c 
		      
		      add_const_leq(cons: [p1#'<='(a#const b) p2#'-'(c x#var b)]
				    del: [p1 p2]
				    add: ['<='(x '-'(c a))]
				    trace: nil
				   )
		      %      a <= (c - x#var)   -->  x#var <= c - a
		      
		      sub_const_leq2(cons: [p1#'<='(a b#const) p2#'+'(c x#var a)]
				     del: [p1 p2]
				     add: ['<='(x '-'(b c))]
				     trace: nil
				    )
		      %      x#var + c <= b   -->  x#var <= b - c
		      
		      
% 		       sub1_right(cons: [p1#'<='(a b) p2#'-'(x#var d b) ]
% 				  del: [p1 p2]
% 				  add: ['<='('+'(d a) x)])
% 		       %     a <= x#var - d    --> d + a <= x#var

% 		      mult_denom1_guard(cons: [p1#'>'(a b) p2#'/'(c d a) '*'(e x#var c)]
% 					del: [p1 p2]
% 					add: ['>'(c '*'(d b))]
% 					guard: ['>'(d 0.0)])
		      %      (e * x#var)/d > b  [d>0] -->  e * x#var > d * b
		      
		      
% 		      greater_lower_leq2(cons: ['<='(a#var b) p1#'>'(a c)]
% 					 ass:  ['<='(c b)]
% 					 del: [p1]
% 					 add: nil)


% 		      solve_less_leq1(cons: [p1#'>'(a#var 0.0) p2#'<='(a c) '/'(d e c) ]
% 				      ass: ['>'(d 0.0)]
% 				      guard: ['>'(e 0.0)]
% 				      del: [p1]
% 				      add: nil
% 				      trace: [dummy(   ])
% 		      % FALL FUER SUCHE!!!!!!

% 		      smaller_leq_upper1(cons: ['>='(b x#var) p1#'>='(c x#var)]
% 					 ass: ['<='(b c)]
% 					 del: [p1]
% 					 add: nil)
		      
% 		      smaller_leq_upper1(cons: [p1#'>='(b x#var) '>='(c x#var)]
% 					 ass: ['<='(c b)]
% 					 del: [p1]
% 					 add: nil)

% 		  greater_lower_bound(cons: [p1#'>'(a b) p2#'>'(a c) '>'(c b)]
% 				      del: [p1]
% 				      add: nil)
		  
% 		  less_leq_trans(cons: [p1#'>'(a b) p2#'<='(c a) '>'(c b)]
% 				 del: [p1]
% 				 add: nil)
%
		     ]
   AllRules = {Append ConstrAssRules ConstrSimpRules}
   NewConstrRules = [failure1(lhs: ['>'(a b) '>'(b c) '>'(c a)]
			      rhs: failure
			      guard: nil)
		      %      a>b>c>a    --> false
		     
		     solve_min_leq(lhs: ['<='(x#var b) '<='(x c) '>'(x d) '>'(b d) '>'(c d) ]
				   rhs: [p1 p2]
				   add: [ '<='(x 'MIN'(b c)) ])  
		      %    d < a#var <=b & a<=c  --> a<= min(b c)
		     
		     solve_max_leq(cons: [p1#'<='(b x#var) p2#'<='(c x) ]
				   del: [p1 p2]
				   add: [ '<='('MAX'(b c) x) ])  
 		      %      b<=a#var & c<=a  --> min(b c) <= a
		     
		     div_first_fac( lhs: ['>'('/'('*'(e x#var) d) b)]
				    rhs: ['>'('*'(e x#var) '*'(d b))]
				    guard: ['>'(d 0.0)])
		      %      (c * x#var) > b & c>0  -->  x#var > b/c
		     
		     mult_denom1(cons: [p1#'>'(a b) p2#'/'(c d a) p3#'*'(e x#var c) '>'(d 0.0)]
				 del: [p1 p2]
				 add: ['>'(c '*'(d b))])
		      %      (e * x#var)/d > b & d>0  -->  e * x#var > d * b
		     
		    ]
end

/*

RULES WITH ALIEN FUNCTIONS
==========================

absval_pos1(cons: [ p1#'||'(a b) p2#'>'(c b) '>='(a 0.0) ]
	    del: [p1 p2]
	    add: [ '>'(c a) ])

absval_pos2(cons: [ p1#'||'(a b) p2#'<='(b c) '>='(a 0.0) ]
			    del: [p1 p2]
	    add: ['<='(a c)])


absval_square(cons: [p1#['||' a b] p2#['*' c c a)]
	      del: [['||' a b] ['*' c c a)]
	      add: [['*' c c b)])
div_div_elim(cons: [p1#['/' 1.0 y z] p2#['/' 1.0 w y)]
	     del: [p1 p2]
	     add: [['=' w z)])

sub_zero_right(cons: [p1#['-' a 0.0 b)]
	       del: ['-' a 0.0 b]
	       add: [['=' a b)])

add_zero_left(cons: [p1#['+' 0.0 a b)]
	      del: ['+' 0.0 a b]
	      add: [['=' a b)])


solve_max(cons: [p1#['<=' b a] p2#['<=' c a)]
		      del: [['<=' b a]['<=' c a)]
	  add: [['<=' ['max' b c) a)])
	    
solve_grt_less(cons: [p1#['>' a b] p2#['<' a c)]
	       del: [p1#['>' a b] p2#['<' a c)]
	       add: [['=' a ['/' ['+' b c] 2.0)]])

solve_grt_leq(cons: [p1#['>' a b] p2#['<=' a c)]
	      del: [p1#['>' a b] p2#['<=' a c)]
	      add: [['=' a ['/' ['+' b c] 2.0]]])

solve_min_leq('if'(cons: [p1#'<='(x#var b) p2#'<='(x c) p3#'>'(x d)]
		   ass: ['>'(b d) '>'(c d)])
	      'then'(del: [p1 p2 p3]
		     add: [ '<='(x 'MIN'(b c))]
		     trace: ['min-greater'(lhs: ['<'(d b) '<'(d c)]
					   rhs: ['<'(d 'MIN'(b c))]
					   args: [b c d]
					  )
			     'min-leq-left'(rhs: ['<='('MIN'(b c) b)]
					    args: [b c])
			     'min-leq-right'(rhs: ['<='('MIN'(b c) c)]
					     args: [b c])
			    ]))

	    
*/
