%%%
%%% COSIE service
%%%

functor
   
import
   Error
   OS(getEnv /*tmpnam*/)

   XService(manager: ServiceManager)
   at 'x-ozlib://mathweb/sys/XService.ozf'
   SimpleServiceClass('class': SimpleService)
   at 'x-ozlib://mathweb/sys/SimpleService.ozf'

   XApplication
   at 'x-ozlib://mathweb/share/XApplication.ozf'
   CosieClass('class':Cosie)
   at 'x-ozlib://mathweb/cs/cosie/CosieClass.ozf'
   
define
   AppName     = 'cosie'
   ServiceName = 'COSIE'
   App         = {New XApplication.manager init}
   CommandClass =  Cosie
   
   fun {ExceptionToVS ERROR}
      {Error.messageToVirtualString {Error.exceptionToMessage ERROR}}
   end
   
   class CosieService from SimpleService
      feat
	 BrokerURL
         BrokerTicket
	 client
	 args

	 commandObj
	 
      meth init(url:     URL    <= false
                cmdArgs: Args   <= unit
		ticket:  Ticket <= false
                done:    ?Done  <= _
               ) = Init
	 {App.show URL#Ticket}
	 self.BrokerURL    = URL
	 self.BrokerTicket = Ticket 
	 self.commandObj    = {New CommandClass init(App BrokerURL)}
	 {App.show URL#Ticket}
         SimpleService, Init
      end
	 
      meth enter(client : ClientName
		 display: Display <= _
		 args   : ArgRec  <= unit)
	 
	 self.client = ClientName
	 self.args   = ArgRec
      end

      meth Apply(Meth ?Result)
	 %{App.show 'Apply'#Meth}
	 fun {GetFirstUnusedIntFeature R Start}
	    if {HasFeature R Start} then
	       {GetFirstUnusedIntFeature R Start+1}
	    else Start end
	 end
	 I = {GetFirstUnusedIntFeature Meth 1}
	 Ar= {Arity Meth}
	 M = {MakeRecord {Label Meth} I|Ar}
      in
	 {ForAll Ar proc {$ X} M.X=Meth.X end}
	 %{App.show 'M'#M}
	 M.I=Result
	 {self.commandObj M}
      end
      
      meth exec(Command ?Result)
	 %{App.show 'Executing'#Command}
	 if {IsDet Command} andthen {IsRecord Command}
	 then
	    try
	       LocalResult in
	       CosieService, Apply(Command ?LocalResult)
	       Result = LocalResult
	    catch ERROR then
	       Result = 'ERROR'(2 'Cosie: Error while executing command.'#
				{ExceptionToVS ERROR})
	    end
	 else Result = 'ERROR'(1 'Cosie: Specified command-method is not a record.')
	 end
      end
      
      meth kill
	 skip
      end
      
      meth leave
%%	 {@commandObj terminate}   %% commandObj could not be bound
	 {Thread.terminate {Thread.this}}
      end
      
   end % of class 
   
   ServMan = {New ServiceManager init(ServiceName CosieService
				      appName: AppName
				      appMan:  App)}
   {ServMan offerService}
   {App.exit 0}
end

