%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ConfigCosie.oz ; This file is part of the OMEGA system
%
%   major updates: 26.10.1999,
%
%   Authors: Juergen Zimmer
%
%   email: jzimmer@ags.uni-sb.de
%   
% For information about this program, write to:                          
%   OMEGA Project                                                        
%   AG Siekmann/FB Informatik                                            
%   Universitaet des Saarlandes                                          
%   Bau 36, 4. Stock                                                     
%   D-66041 Saarbruecken                                                 
%   Germany    
%
% For information about the newest version of Omega, see 
%   http://www.ags.uni-sb.de/~omega/
%
% This program is free software; it can be used under the terms of the GNU General
% Public License as published by the Free Software Foundation; either version 2 of
% the License, or any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% merchantibility or fitness for a particular purpose. 
% See the GNU General Public License 
% (http://www.fsf.org/copyleft/gpl.html)
% for more details.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
functor     
   %%  the file with all configuration data for CoSIE
export
   NodeColour
   PropColour
   EventColour
   EdgeColour
   
define
   NodeColour      = darkolivegreen2
   PropColour      = steelblue2
   EventColour     = lightyellow1
   EdgeColour      = black
   
   
   
end

%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% %%
%%    The LOUI Config file!                                                                       %%
%% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% %%

%% Global default settings
/*
FactorsToCm      =cTo(i: 2.54
		      c: 1.00
		      m: 10.0
		      p: 0.035277778)

DefOptions = o(drawing:    o(scale: false
			     limit: false
			     depth: 10)
	       postscript: o(color:       if Tk.isColor then color
					  else mono
					  end
			     width:       6.5 * FactorsToCm.i
			     height:      9.5 * FactorsToCm.i
			     size:        "6.5ix9.5i"
			     orientation: false))

DefEdit = e(limit : e(depth: 10)
	    search: e(string : ""
		      feature: label))

TitleName  = 'Lovely Omega User Interface'
AboutText  = 'Version 0.8b\n\n'#
             'Stephan M. Hess\n'#
             '(hess@ags.uni-sb.de)'

StartSizeX   = 1152
StartSizeY   = 864
StartOffsetX = 64
StartOffsetY = 60 %100 80
MinSizeX     = 680
MinSizeY     = 510

%% Configuration of the scale bar
IntScaleBase    = 256
FloatScaleBase  = {IntToFloat IntScaleBase}
MinScale = 0.05 / FloatScaleBase
MaxScale = 2.00 / FloatScaleBase
DefScale = 1.00 / FloatScaleBase

FontFamily      = '-*-helvetica-medium-r-normal--*-'
BoldFontFamily  = '-*-helvetica-bold-r-normal--*-'
FontMatch       = '-*-*-*-*-*-*'
NumberFonts     = [font(name:FontFamily#180#FontMatch scale:1.8/FloatScaleBase)
		   font(name:FontFamily#140#FontMatch scale:1.4/FloatScaleBase)
		   font(name:FontFamily#120#FontMatch scale:1.2/FloatScaleBase)
		   font(name:FontFamily#100#FontMatch scale:1.0/FloatScaleBase)
		   font(name:FontFamily# 80#FontMatch scale:0.8/FloatScaleBase)]
StatusFont      = FontFamily#100#FontMatch
BoldStatusFont  = BoldFontFamily#100#FontMatch

%% Width of the scroller, applies also to the width of the scale
ScrollerWidth   = 12

%% Some parameters used in packing the canvas
Border          = 1 %2
Pad             = 2
BigPad          = 4
HugePad         = 8
RuleEntryWidth  = 30
NodeEntryWidth  = 15
LargeEntryWidth = 20
SmallEntryWidth = 6
URLEntryWidth   = 60
CommandEntryWidth = 40

%% Distance between nodes
HorSpaceI        = 32 * IntScaleBase
VerSpaceI        = 38 * IntScaleBase
%HorSpaceF        = {IntToFloat HorSpaceI}
VerSpaceF        = {IntToFloat VerSpaceI}

HalfHorSpaceI    = HorSpaceI div 2
HalfVerSpaceI    = VerSpaceI div 2
HalfHorSpaceF    = {IntToFloat HalfHorSpaceI}
HalfVerSpaceF    = {IntToFloat HalfVerSpaceI}

%% Initial coordinates of the root of the tree
RootX            = 0
RootY            = HalfVerSpaceI
SentinelX        = RootX
SentinelY        = RootY - VerSpaceI

%% Time (in ms) for delay of poping up the help marks

HelpDelay = 750

%% Sizes for the nodes and links
ShapeWidthI      = 10 * IntScaleBase
ShapeWidthF      = {IntToFloat ShapeWidthI}
SmallShapeWidthI = 6 * IntScaleBase
SmallShapeWidthF = {IntToFloat SmallShapeWidthI}
BigShapeWidthI   = 12 * IntScaleBase
BigShapeWidthF   = {IntToFloat BigShapeWidthI}

ImageSize           = 18.0
ImageCenter         = ImageSize / 2.0
ImageScale          = 0.6 / FloatScaleBase
MaxExtent           = 12.0 * FloatScaleBase

NodeBorderWidth = 1
LinkWidth       = 1

% Set up some colors

PopupColor = 'lightyellow'
LineColor  = black
BackColor  = white
EntryColor = wheat
			  
% ProofNode shapes and colors

OpenNodeShape       = square
UntestedNodeShape   = diamond
GroundNodeShape     = circle
ExpandedNodeShape   = circle
UnexpandedNodeShape = circle
AssumptionShape     = prism
AssertionShape      = prism
HypothesisShape     = prism
LinkNodeShape       = triangle

OpenNodeColor       = '#ffff30213021' % firebrick1
UntestedNodeColor   = '#8b851a171a17' % firebrick4
GroundNodeColor     = '#004200008083' % NavyBlue
ExpandedNodeColor   = '#48317624ffff' % RoyalBlue1
UnexpandedNodeColor = '#876ccecdffff'
AssumptionColor     = '#0000cdd26616' % SpringGreen3
AssertionColor      = '#ee5eeed80000' % yellow2
HypothesisColor     = '#eed876f20000' % DarkOrange2
LinkNodeColor       = '#a9baa9baa9ba' % DarkGrey

%
% Command Dialog
%

TypeToInfo = t('NDLINE'             : "Node"
	       'NDPLANLINE'         : "Node"
	       'NDLINE-LIST'        : "List of Nodes"
	       'TERM'               : "Term"
	       'TERM-LIST'          : "List of Terms"
	       'TERMSYM'            : "Constant"
	       'TERMSYM-LIST'       : "List of Constants"
	       'POSITION'           : "List of Positions"
	       'SYMBOL'             : "Symbol"
	       'THY-ASSUMPTION'     : "Assumption"
	       'BOOLEAN'            : "Boolean"
	       'STRING'             : "String"
	       'EXISTING-DIRECTORY' : "Directory"
	       'INTEGER'            : "Integer"
	       'PATHNAME'           : "Pathname")

BrowserNormalFont = 'louistd'

%
% The ticket's name to connect to
%

TicketName = 'broker-ticket.ozc'
*/
