%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Window.oz ; This file is part of the OMEGA system
%
%   major updates: 28.6.1999,
%
%   Authors: Juergen Zimmer
%
%   email: jzimmer@ags.uni-sb.de
%   
% For information about this program, write to:                          
%   OMEGA Project                                                        
%   AG Siekmann/FB Informatik                                            
%   Universitaet des Saarlandes                                          
%   Bau 36, 4. Stock                                                     
%   D-66041 Saarbruecken                                                 
%   Germany    
%
% For information about the newest version of Omega, see 
%   http://www.ags.uni-sb.de/~omega/
%
% This program is free software; it can be used under the terms of the GNU General
% Public License as published by the Free Software Foundation; either version 2 of
% the License, or any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% merchantibility or fitness for a particular purpose. 
% See the GNU General Public License 
% (http://www.fsf.org/copyleft/gpl.html)
% for more details.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

functor
   %% The class of constraint display windows
   %%      jzimmer 28.6.99 
import
%   System(show:Show print:Print showInfo printInfo)
%   Browser(browse: Browse)
   Tk
   
   TermPrinter
   at 'x-ozlib://mathweb/loui/TermPrinter.ozf'
   
export
   'class': ConstraintPrinter

define
   BrowserNormalFont = 'louistd'
   %PopupColor = '#eeeeeeeeeeee'
   PopupColor = '#ffffffffffff'
   
   class ConstraintPrinter
      feat
	 Top
	 Text
	 termPrinter
	 
      attr
	 Row
	 Column
	 
      meth init(Title)
	 W = {New Tk.toplevel tkInit(title: Title)}
	 
	 T = {New Tk.text  tkInit(parent:             W
				  bg:                 PopupColor
				  border:             0
				  font:               BrowserNormalFont
				  highlightthickness: 0
				  setgrid: 1
				  wrap  : none)}
	 
	 ScrY = {New Tk.scrollbar tkInit(parent: W
					 relief: sunken
					 bd:     1
					 width:  12)}

	 Printer = {New TermPrinter.'class' init(T false)}
      in
	 {Tk.addYScrollbar T ScrY}
	 {Tk.batch [grid(T row:0 column:0 sticky:nswe)
		    grid(ScrY row:0 column:1 sticky:ns)]}
	 %%{Tk.addYSrollbar W ScrY}
	 
	 self.Top = W
	 self.Text = T
	 self.termPrinter = Printer
	 Row    <- 1
	 Column <- 0
      end

      meth printTerm(T)
	 Len = {self.termPrinter show(T @Row @Column $)}
      in
	 Column <- @Column + Len
      end
      
      meth print(T)
	 Len = {Length T}
      in
	 {self.Text tk(insert @Row#'.'#@Column T)}
	 Column <- @Column + Len
      end
      
      meth nextLine(?C)
	 C = @Column
	 {self.Text tk(insert @Row#'.'#@Column '\n')}
	 Row    <- @Row + 1
	 Column <- 0
      end
      
      meth popup(Width Height)
	 {self.Text tk(conf width:Width height:Height)}
	 ConstraintPrinter,deiconify
      end

      meth newTitle(Title)
	 {Tk.send wm(title self.Top Title)}
      end
      
      meth clear
	 {self.Text tk(delete '1.0' 'end')}
	 Row <- 1
	 Column <- 0
      end
      
      meth close
	 {self.Top tkClose}
      end
      
      meth iconify
	 {Tk.send wm(iconify self.Top)}
      end

      meth deiconify
	 {Tk.send wm(deiconify self.Top)}
      end
   end
   

end %define
